Page MenuHomePhabricator

Provide "phutil_build_http_querystring()", like "http_build_query()" but not wrong by default
ClosedPublic

Authored by epriestley on Jan 28 2019, 11:10 PM.

Details

Summary

See D20039. Although http_build_query() works fine for the most part, it does the wrong thing by default if arg_separator.output is set in configuration.

Provide a wrapper which forces the expected behavior.

Test Plan

Ran unit tests.

Diff Detail

Repository
rPHU libphutil
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

epriestley created this revision.Jan 28 2019, 11:10 PM
epriestley requested review of this revision.Jan 28 2019, 11:11 PM
epriestley added inline comments.Jan 28 2019, 11:31 PM
src/markup/engine/remarkup/blockrule/PhutilRemarkupTestInterpreterRule.php
14

HA HA HA THIS TEST WOULD PREVIOUSLY FAIL UNDER UNUSUAL VALUES OF arg_separator.output HA HA HA PHP

amckinley requested changes to this revision.Jan 29 2019, 3:25 AM

Marking this as changes requested because I think the PhutilURI.php change is wrong.

src/markup/engine/remarkup/blockrule/PhutilRemarkupTestInterpreterRule.php
14

yourewelcome

src/parser/PhutilURI.php
177

Dangling arguments?

This revision now requires changes to proceed.Jan 29 2019, 3:25 AM
epriestley added inline comments.Jan 29 2019, 3:25 AM
src/parser/PhutilURI.php
177

Ah, thanks!

epriestley updated this revision to Diff 47884.Jan 29 2019, 3:27 AM
  • Remove dangling arguments.
amckinley accepted this revision.Jan 29 2019, 3:33 AM
This revision is now accepted and ready to land.Jan 29 2019, 3:33 AM
epriestley updated this revision to Diff 47887.Jan 29 2019, 1:49 PM
  • Switch to PHP_QUERY_RFC3986 mode.
  • Add unit tests.

This corresponds to rawurlencode(). The default mode (PHP_QUERY_RFC1738) corresponds to urlencode().

The only differences for this new mode are:

  • Space is encoded as %20 (instead of +).
  • "~" is not encoded (instead of %7F).

The space encoding as %20 seems strongly preferable, since any reasonable parser can and should handle it unambiguously, while the meaning of + to parsers is ambiguous.

This is also what Duo (at least) expects, and what we'd expect ourselves.

epriestley updated this revision to Diff 47888.Jan 29 2019, 1:51 PM
  • Use rawurlencode(), not http_build_query(), because PHP_QUERY_RFC3986 requires PHP 5.4 or newer.
epriestley requested review of this revision.Jan 29 2019, 1:52 PM

This could probably use another quick look, see also D20053.

I added a note for the version thing in T7408.

amckinley accepted this revision.Jan 30 2019, 6:20 AM
This revision is now accepted and ready to land.Jan 30 2019, 6:20 AM
This revision was automatically updated to reflect the committed changes.